(*
 * Test question 1
 *)

open Question1

(* Partie test: ne pas modifier *)
let _ =
  let rec list_of_int accu = function
      0 -> 0::accu
    | n -> list_of_int (n::accu) (n-1)
  in
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let usage = "Prog TP: question 1\nquestion1 u0 r graine iterations" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| u0::r::seed::iter::_ ->
	    Random.init seed;
	    for i = 0 to iter do
	      let n = Random.int 1000 in
		Printf.printf "suite %i %i %i = %i\n" u0 r n (suite u0 r n);
	    done;
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
