(*
 * Test question 2
 *)

open Question2

(* Partie test: ne pas modifier *)
let _ =
  let rec list_of_int accu = function
      0 -> 0::accu
    | n -> list_of_int (n::accu) (n-1)
  in
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let usage = "Prog TP: question 2\nquestion2 graine iteration" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| seed::iter::_ ->
	    Random.init seed;
	    for i = 0 to iter do
	      let base = Random.int 10 in
	      let rang = Random.int 10000 in
	      let res  = serie (fun n -> n+base) rang in
		Printf.printf "serie (fun n -> n+%i) %i = %i\n" base rang res;
	    done;
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
