(*
 * Test question 6
 *)

open Question6

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let print_rec r =
    Printf.printf "{ a = %i ; b = %i } " r.a r.b
  in
  let print_listrec l =
    Printf.printf "[ ";
    List.iter (print_rec) l;
    Printf.printf "]"
  in
  let print_int_list l =
    Printf.printf "[ ";
    List.iter (Printf.printf "%d; ") l;
    Printf.printf "]"
  in
  let rec gen_list accu = function
      0 -> accu
    | n when n>0 ->
	let r = {a = (Random.int 10) ; b = (Random.int 10)} in
	gen_list (r::accu) (n-1)
    | _ -> Printf.fprintf stderr "taille doit etre positif !" ; exit 2
  in
  let usage = "Prog TP: question 6\nquestion6 graine taille" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| seed::size::_ ->
	    Random.init seed;
	    let l = gen_list [] size in
	      Printf.printf "l = " ;
	      print_listrec l;
	      Printf.printf "\nlistrec2reclist l = \n" ;
	      let r = listrec2reclist l in
		Printf.printf "{ c = ";
		print_int_list r.c;
		Printf.printf " ; d = ";
		print_int_list r.d;
		Printf.printf " }\n";
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
