(*
 * Test question 10
 *)

open Question10

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let cycle =
    let c = ref 0 in
      function () -> c := !c + 1; !c
  in
  let rec new_tree () =
    if (cycle() > 64 || ((cycle() mod 15) <> 0 && Random.bool ())) then
      Nil
    else
      Node(Random.int 50,new_tree(),new_tree())
  in
  let usage = "Prog TP: question 10\nquestion10 graine" in
    Arg.parse (Arg.align []) anonfun usage ;
    ( try
	match get_liste () with
	  | seed::_ ->
	      Random.init seed;
	      let t = new_tree () in
		Printf.printf "%s\n" (to_string (string_of_int) t);
		exit 0
	  | _ ->
	      Arg.usage (Arg.align []) usage ;
	      exit 1
      with
	  Invalid_argument("Mauvaises bornes.") ->
	    Printf.fprintf stderr "Mauvaises bornes.\n";
	    exit 3
    )
