(*
 * Test question 5
 *)

open Question5

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let print_int_list l =
    Printf.printf "[ ";
    List.iter (Printf.printf "%d; ") l;
    Printf.printf "]"
  in
  let rec gen_list accu = function
      0 -> accu
    | n when n>0 -> gen_list ((Random.int 10)::accu) (n-1)
    | _ -> Printf.fprintf stderr "taille doit etre positif !" ; exit 2
  in
  let usage = "Prog TP: question 5\nquestion5 graine taille" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| seed::size::_ ->
	    Random.init seed;
	    let l = gen_list [] size in
	      Printf.printf "l = " ;
	      print_int_list l;
	      Printf.printf "\npartie est_pair l = \n" ;
	      let (x,y) = partie (fun x -> x mod 2 = 0) l in
		Printf.printf "(";
		print_int_list x;
		Printf.printf " , ";
		print_int_list y;
		Printf.printf ")\n";
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
