(*
 * Test question 7
 *)

open Question7

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let rec fact a = function
      0|1 -> a
    | n when n>0 -> fact (n*a) (n-1)
    | _ -> 0
  in
  let usage = "Prog TP: question 7\nquestion7 max" in
    Arg.parse (Arg.align []) anonfun usage ;
    (
      match get_liste () with
	| n::_ ->
	    Printf.printf "!0 ... !%i = " n;
	    for i = 0 to n do
	      Printf.printf "%i " (next_fact ())
	    done ;
	    Printf.printf "\n";
	    exit 0
	| _ ->
	    Arg.usage (Arg.align []) usage ;
	    exit 1
    )
