(*
 * Test question 8
 *)

open Question8

(* Partie test: ne pas modifier *)
let _ =
  let q = Queue.create () in
  let anonfun s =
    try
      let x = int_of_string s in
	Queue.add x q
    with
	_ -> ()
  in
  let get_liste () =
    List.rev (Queue.fold (fun x y -> y::x) [] q)
  in
  let print_tab_int t =
    Printf.printf "[|";
    Array.iter (Printf.printf " %d;") t;
    Printf.printf " |] "
  in
  let usage = "Prog TP: question 8\nquestion8 graine taille i j" in
    Arg.parse (Arg.align []) anonfun usage ;
    ( try
	match get_liste () with
	  | seed::size::i::j::_ ->
	      Random.init seed;
	      let t = Array.init size (fun _ -> Random.int 100) in
	      let res = (somme_tab t i j) in
		Printf.printf "t = ";
		print_tab_int t;
		Printf.printf "\nsomme_tab t %d %d = %d\n" i j res;
		exit 0
	  | _ ->
	      Arg.usage (Arg.align []) usage ;
	      exit 1
      with
	  Invalid_argument("Mauvaises bornes.") ->
	    Printf.fprintf stderr "Mauvaises bornes.\n";
	    exit 3
    )
